-- Coded by: Exzu / EU-Aszune

textTable = {
	ANT = { outLine = "OUTLINE", fontSize = "14", loc = "TOP", x = 0, y = 8, color = {1, 1, 1, 1}, text = "Satchel Scanner", },
	statusText = { outLine = "OUTLINE", fontSize = "16", loc = "LEFT", x = 5, y = 61, color = {0, 1, 0, 1}, text = "Current Status:", },
	scanText = { outLine = "OUTLINE", fontSize = "16", loc = "LEFT", x = 95, y = 61, color = {1, 0, 0, 1}, text = "Not Running", },
	tankText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 22, y = 45, color = {1, 1, 1, 1}, text = "Tank:", },
	tankScanningText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 52, y = 45, color = {1, 0, 0, 1}, text = "Not Scanning...", },
	tankdg1 = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 6, y = 29, color = {0, 0.6, 0.8, 1}, text = "# ...", },
	healerText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 22, y = 13, color = {1, 1, 1, 1}, text = "Healer:", },
	healScanningText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 62, y = 13, color = {1, 0, 0, 1}, text = "Not Scanning...", },
	healdg1 = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 6, y = -3, color = {0, 0.6, 0.8, 1}, text = "# ...", },
	dpsText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 22, y = -19, color = {1, 1, 1, 1}, text = "DPS:", },
	dpsScanningText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 47, y = -19, color = {1, 0, 0, 1}, text = "Not Scanning...", },
	dpsdg1 = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 6, y = -35, color = {0, 0.6, 0.8, 1}, text = "# ...", },
	bagCounter = { outLine = "OUTLINE", fontSize = "14", loc = "TOP", x = 116, y = -23, color = {0, 0.6, 0.8, 1}, bag = true, text = "0", },
};

frameTable = {
	scanButton = { zscale = 0, zxscale = 0, yscale = 22/32, xscale = 80/128, texture = true, Type = "Button", width = "80", height = "25", loc = "BOTTOM", x = -80, y = 5, text = "Start", script = true, functionName = "startScanning()", normalTxt = "Interface\\Buttons\\UI-Panel-Button-Up.blp", pushedTxt = "Interface\\Buttons\\UI-Panel-Button-Down.blp", highLightTxt = "Interface\\Buttons\\UI-Panel-Button-Highlight.png", },
	stopButton = { zscale = 0, zxscale = 0, yscale = 22/32, xscale = 80/128, texture = true, Type = "Button", width = "80", height = "25", loc = "BOTTOM", x = 80, y = 5, text = "Stop", script = true, functionName = "stopScanning()", normalTxt = "Interface\\Buttons\\UI-Panel-Button-Up.blp", pushedTxt = "Interface\\Buttons\\UI-Panel-Button-Down.blp", highLightTxt = "Interface\\Buttons\\UI-Panel-Button-Highlight.png", },
	configButton = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, texture = true, Type = "Button", width = "16", height = "16", loc = "TOP", x = 97, y = -5, script = true, functionName = "InterfaceOptionsFrame_OpenToCategory(SatchelScanner.childpanel)", normalTxt = "Interface\\Addons\\SatchelScanner\\icons\\config.tga", pushedTxt = "Interface\\Addons\\SatchelScanner\\icons\\configpush.tga", highLightTxt = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp", },
	closeButton = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, texture = true, Type = "Button", width = "16", height = "16", loc = "TOP", x = 115, y = -5, script = true, functionName = "hideMainFrame()", normalTxt = "Interface\\Addons\\SatchelScanner\\icons\\close.tga", pushedTxt = "Interface\\Addons\\SatchelScanner\\icons\\closepush.tga", highLightTxt = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp", },
	bagIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "16", height = "16", loc = "TOP", x = 97, y = -23, normalTxt = "Interface\\Addons\\SatchelScanner\\icons\\bagIcon.tga", },
	tankIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "15", height = "15", loc = "LEFT", x = 6, y = 45, normalTxt = "Interface\\Addons\\SatchelScanner\\icons\\tankIcon.tga", },
	healIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "15", height = "15", loc = "LEFT", x = 6, y = 13, normalTxt = "Interface\\Addons\\SatchelScanner\\icons\\healerIcon.tga", },
	dpsIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "15", height = "15", loc = "LEFT", x = 6, y = -19, normalTxt = "Interface\\Addons\\SatchelScanner\\icons\\dpsIcon.tga", },
};

-- Variables
local playSound = true;
local raidWarnNotify = true;
local UpdateInterval = 5;
local running = false;
local scanForTank = true;
local scanForHeal = true;
local scanForDps = false;
local runVar = {"Not Running", "Running"};
local addonVersion = 7.04;
local satchelFound = false;
local satchelsReceived = 0;
local showUI = true;
local scanInDungeon = false;
local instanceScan = true;
local groupScan = true;
local scanInGroup = true;

-- Dungeon Scan Var
local heroicVar = {"# Legion Heroic!", "# Not used...!"};
local scanVar = {"# ...", "# Searching..."};
local classScan = {"Not Scanning...","Scanning...","Satchel Found!"};
local ctaVar = {"Call to Arms: Tank","Call to Arms: Healer","Call to Arms: Dps"};


-- Addon Colors
--local colors = { red = {1,0,0,1}, green = {0,1,0,1}, yellow = {1,1,0,1}, } -- To be used in an upcoming table
local redColor = {1,0,0,1};
local greenColor = {0,1,0,1};
local yellowColor = {1,1,0,1};

function stopScanning()
	if running then
		satchelFound = false;
		running = false;
		textTable.scanText.textFrame:SetTextColor(unpack(redColor));
		textTable.scanText.textFrame:SetText(runVar[1]);
		textTable.tankScanningText.textFrame:SetText(classScan[1]);
		textTable.tankScanningText.textFrame:SetTextColor(unpack(redColor));
		textTable.healScanningText.textFrame:SetText(classScan[1]);
		textTable.healScanningText.textFrame:SetTextColor(unpack(redColor));
		textTable.dpsScanningText.textFrame:SetText(classScan[1]);
		textTable.dpsScanningText.textFrame:SetTextColor(unpack(redColor));
		textTable.tankdg1.textFrame:SetText(scanVar[1]);
		textTable.healdg1.textFrame:SetText(scanVar[1]);
		textTable.dpsdg1.textFrame:SetText(scanVar[1]);
	end
end

function startScanning()
	if not running and (scanForTank or scanForHeal or scanForDps) then
		running = true
		textTable.scanText.textFrame:SetTextColor(unpack(greenColor));
		textTable.scanText.textFrame:SetText(runVar[2]);
		if scanForTank then
			textTable.tankdg1.textFrame:SetText(scanVar[2]);
		end
		if scanForHeal then
			textTable.healdg1.textFrame:SetText(scanVar[2]);
		end
		if scanForDps then
			textTable.dpsdg1.textFrame:SetText(scanVar[2]);
		end
		RequestLFDPlayerLockInfo();
	elseif not running and not (scanForTank or scanForHeal or scanForDps) then
		print("Must scan for atleast one class before starting the program!");
	end
end

function hideMainFrame()
	MainFrame:Hide();
	tableAdd("showMainFrame", false);
end

-- Scanner - DO NOT MODIFY!
function satchelFinder(role, id)
		local eligible, forTank, forHealer, forDamage, itemCount, money, xp = GetLFGRoleShortageRewards(id, 1)
		if (itemCount ~= 0 or money ~= 0 or xp ~= 0) then
			if forTank and scanForTank and role == "tank" then
				return true;
			end
			if forHealer and scanForHeal and role == "heal" then
				return true;
			end
			if forDamage and scanForDps and role == "dps" then
				return true;
			end
		end
end


function uiConfig() -- Draws Config Panel --
	SatchelScanner = {};
	SatchelScanner.panel = CreateFrame("Frame", "SatchelScannerInfo", UIParent );
	SatchelScanner.panel.name = "Satchel Scanner";
	InterfaceOptions_AddCategory(SatchelScanner.panel);

	SatchelScanner.childpanel = CreateFrame("Frame", "SatchelScannerConfig", SatchelScanner.panel);
	SatchelScanner.childpanel.name = "Options";
	SatchelScanner.childpanel.parent = SatchelScanner.panel.name;
	InterfaceOptions_AddCategory(SatchelScanner.childpanel);
	SatchelScanner.panel.okay = function(self) datacall("update"); end;
	
 	configurationText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	configurationText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 18, "OUTLINE");
	configurationText:SetPoint("TOP", 0, -7);
	configurationText:SetText("Satchel Scanner Configuration!");
	-- Scanner Options
	scanOptionText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanOptionText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 16, "OUTLINE");
	scanOptionText:SetPoint("TOPLEFT", 10, -16);
	scanOptionText:SetText("|cffff0000Scanning Options|r");
	-- Tank CheckBox
	scanForTankButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForTankButton:SetPoint("TOPLEFT", 8, -32);
 	scanForTankText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForTankText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForTankText:SetPoint("TOPLEFT", 30, -36);
	scanForTankText:SetText("Scan for Tank Satchels");
	-- Healer CheckBox
	scanForHealButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForHealButton:SetPoint("TOPLEFT", 8, -52);
 	scanForHealText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForHealText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForHealText:SetPoint("TOPLEFT", 30, -56);
	scanForHealText:SetText("Scan for Healer Satchels");
	-- Dps CheckBox
 	scanForDpsButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForDpsButton:SetPoint("TOPLEFT", 8, -72);
 	scanForDpsText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForDpsText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForDpsText:SetPoint("TOPLEFT", 30, -76);
	scanForDpsText:SetText("Scan for Dps Satchels");
	-- Scan while inside an instance
	scanInDungeonButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanInDungeonButton:SetPoint("TOPLEFT", 8, -92);
 	scanInDungeonText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanInDungeonText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanInDungeonText:SetPoint("TOPLEFT", 30, -96);
	scanInDungeonText:SetText("Scan while in Instance");
	-- Scan while in Group
	scanInGroupButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanInGroupButton:SetPoint("TOPLEFT", 8, -112);
 	scanInGroupText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanInGroupText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanInGroupText:SetPoint("TOPLEFT", 30, -116);
	scanInGroupText:SetText("Scan while in Group");
	-- Notifications
	scanOption2Text = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanOption2Text:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 16, "OUTLINE");
	scanOption2Text:SetPoint("TOPLEFT", 10, -142);
	scanOption2Text:SetText("|cffff0000Notification Options|r");
	-- Sound CheckBox
	playSoundButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	playSoundButton:SetPoint("TOPLEFT", 8, -158);
 	playSoundText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	playSoundText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	playSoundText:SetPoint("TOPLEFT", 30, -162);
	playSoundText:SetText("Play Soundwarning");
	-- Raidwarning CheckBox
	raidWarningButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	raidWarningButton:SetPoint("TOPLEFT", 8, -178);
 	raidWarningText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	raidWarningText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	raidWarningText:SetPoint("TOPLEFT", 30, -182);
	raidWarningText:SetText("Show Raidwarning");
	-- Slider for Scanner Interval
	sliderText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	sliderText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 16, "OUTLINE");
	sliderText:SetPoint("TOPLEFT", 145, -225);
	sliderText2 = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	sliderText2:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	sliderText2:SetPoint("TOPLEFT", 10, -208);
	sliderText2:SetText("Update Interval in Seconds");
	updateIntervalSlider = CreateFrame("Slider", nil, SatchelScanner.childpanel, "OptionsSliderTemplate")
	updateIntervalSlider:SetPoint("TOPLEFT", 10, -223);
	updateIntervalSlider:SetWidth(130);
	updateIntervalSlider:SetHeight(20);
	updateIntervalSlider:SetOrientation('HORIZONTAL');
	updateIntervalSlider:SetMinMaxValues(3, 15);
	updateIntervalSlider:SetValueStep(1);
	updateIntervalSlider:SetObeyStepOnDrag(true);
	updateIntervalSlider:SetScript("OnValueChanged", function(self) sliderText:SetText(updateIntervalSlider:GetValue()); end)
	updateIntervalSlider:Show();
end

function drawFrames() -- Draws the MainFrame --
	uiConfig();
	MainFrame = CreateFrame("Frame", "DragFrame2", UIParent)
	MainFrame:SetMovable(true)
	MainFrame:EnableMouse(true)
	MainFrame:SetScript("OnMouseDown", function(self, button)
		if button == "LeftButton" and not self.isMoving then
			self:StartMoving();
			self.isMoving = true;
		end
	end)
	MainFrame:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and self.isMoving then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	MainFrame:SetScript("OnHide", function(self)
		if ( self.isMoving ) then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	MainFrame:SetWidth(256);
	MainFrame:SetHeight(150);
	MainFrame:SetPoint("BOTTOMLEFT", 800, 400);
	MainFrame:SetFrameStrata("BACKGROUND")
	MainFrame:SetBackdrop({ 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Addons\\SatchelScanner\\border\\border.tga", tile = false, tileSize = 0, edgeSize = 8, 
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	});
	for i, frameData in pairs(frameTable) do -- This is for drawing each texture.
		frameData.frame = CreateFrame(frameData.Type,nil,MainFrame, UIPanelButtonTemplate);
		frameData.frame:SetWidth(frameData.width);
		frameData.frame:SetHeight(frameData.height);
		frameData.frame:SetPoint(frameData.loc, frameData.x, frameData.y);
		frameData.frame:SetNormalTexture(frameData.normalTxt);
		frameData.frame:SetPushedTexture(frameData.pushedTxt);
		frameData.frame:SetHighlightTexture(frameData.highLightTxt);
		frameData.frame:GetNormalTexture():SetTexCoord(frameData.zxscale,frameData.xscale,frameData.zscale,frameData.yscale);
		if frameData.texture then
			frameData.frame:GetPushedTexture():SetTexCoord(frameData.zxscale,frameData.xscale,frameData.zscale,frameData.yscale);
			frameData.frame:GetHighlightTexture():SetTexCoord(frameData.zxscale,frameData.xscale,frameData.zscale,frameData.yscale);
		end
		if frameData.text then
			local buttonText = frameData.frame:CreateFontString(nil, "OVERLAY")
			buttonText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "");
			buttonText:SetPoint("CENTER", 0, 0);
			buttonText:SetTextColor(unpack(yellowColor));
			buttonText:SetText(frameData.text);
		end
		if frameData.script then
			frameData.frame:SetScript("OnClick", loadstring(frameData.functionName));
		end
	end
end

function drawText() -- Draws the Text -- 
	for i, controlData in pairs(textTable) do
		controlData.textFrame = MainFrame:CreateFontString(nil, "OVERLAY")
		controlData.textFrame:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", controlData.fontSize, controlData.outLine);
		controlData.textFrame:SetPoint(controlData.loc, controlData.x, controlData.y);
		controlData.textFrame:SetTextColor(unpack(controlData.color));
		controlData.textFrame:SetText(controlData.text);
	end
end

-----------------------------
-- DATABASE, DO NOT MODIFY --
-----------------------------
function datacall(datatable)
	if datatable == "reset" then
		SatchelScannerDB = {}
		tableAdd("updateint", 5);
		tableAdd("version", addonVersion);
		tableAdd("raidwarning", true);
		tableAdd("sounds", true);
		tableAdd("scanTank", true);
		tableAdd("scanHeal", true);
		tableAdd("scanDps", false);
		tableAdd("scanInDungeon", false);
		tableAdd("scanInGroup", true);
		tableAdd("satchels", satchelsReceived);
		tableAdd("showMainFrame", true);
		datacall("read");
	elseif datatable == "update" then
		tableAdd("updateint", updateIntervalSlider:GetValue());
		tableAdd("version", addonVersion);
		tableAdd("raidwarning", raidWarningButton:GetChecked());
		tableAdd("sounds", playSoundButton:GetChecked());
		tableAdd("scanTank", scanForTankButton:GetChecked());
		tableAdd("scanHeal", scanForHealButton:GetChecked());
		tableAdd("scanDps", scanForDpsButton:GetChecked());
		tableAdd("scanInDungeon", scanInDungeonButton:GetChecked());
		tableAdd("scanInGroup", scanInGroupButton:GetChecked());
		tableAdd("satchels", satchelsReceived);
		tableAdd("showMainFrame", showUI);
		datacall("read");
	elseif datatable == "read" then
		if not SatchelScannerDB then
			printm("SS3: Your settings have been reset!");
			datacall("reset");
		elseif SatchelScannerDB["version"] < 7.04 then
			satchelsReceived = SatchelScannerDB["satchels"];
			printm("SS3: Your settings have been reset!");
			datacall("reset");
		else
			playSound = SatchelScannerDB["sounds"];
			playSoundButton:SetChecked(playSound);
			raidWarnNotify = SatchelScannerDB["raidwarning"];
			raidWarningButton:SetChecked(raidWarnNotify);
			satchelsReceived = SatchelScannerDB["satchels"];
			textTable.bagCounter.textFrame:SetText(satchelsReceived);
			UpdateInterval = SatchelScannerDB["updateint"];
			updateIntervalSlider:SetValue(UpdateInterval);
			dbVersion = SatchelScannerDB["version"];
			scanForTank = SatchelScannerDB["scanTank"];
			scanForHeal = SatchelScannerDB["scanHeal"];
			scanForDps = SatchelScannerDB["scanDps"];
			scanInDungeon = SatchelScannerDB["scanInDungeon"];
			scanInGroup = SatchelScannerDB["scanInGroup"];
			scanInGroupButton:SetChecked(scanInGroup);
			scanInDungeonButton:SetChecked(scanInDungeon);
			scanForDpsButton:SetChecked(scanForDps);
			scanForTankButton:SetChecked(scanForTank);
			scanForHealButton:SetChecked(scanForHeal);
			showUI = SatchelScannerDB["showMainFrame"];
			if showUI then
				MainFrame:Show();
			else
				MainFrame:Hide();
			end
		end
	else
		errorCollect("DATATABLE", datatable);
	end
end

function tableAdd(var, arg) -- Updates values in tables
	SatchelScannerDB[var] = arg;
end

-------------------------------
-- PRINT, ERROR COLLECT ETC. --
-------------------------------
function errorCollect(e, e2)
	print("|cffff0000==== SS3 ERROR DUMP ====");
	print("|cFF0080FFSS3: |cffffffffINVALID '"..e.."' CALL");
	print("|cFF0080FFSS3: |cffffffffCALL USED WAS: '"..e2.."'");
	print("|cFF0080FFSS3: |cffffffffPLEASE REPORT TO DEVELOPER");
	print("|cffff0000==== END OF SS3 DUMP ====");
end

function printm(msg)
	print("|cFFFF007F" .. msg  .. "|r");
end

----------------------------------
-- ON LOAD, ON UPDATE, ON EVENT --
----------------------------------

function SatchelScanner_OnEvent(self, event, arg, arg2)
	local inInstance = IsInInstance()
	local inLFGQueue = GetLFGQueueStats(LE_LFG_CATEGORY_LFD)
	local inLFRQueue = GetLFGQueueStats(LE_LFG_CATEGORY_LFR)
	local inGroup = IsInGroup()
	-- Scan in Dungeon
	if not scanInDungeon and inInstance then
		instanceScan = false;
	else
		instanceScan = true;
	end
	-- Scan in group
	if not scanInGroup and inGroup then
		groupScan = false;
	else
		groupScan = true;
	end
	if event == "ADDON_LOADED" and arg == "SatchelScanner" then
		datacall("read");
	elseif event == "CHAT_MSG_LOOT" and string.find(arg, "Shattered Satchel of Cooperation") and not (MailFrame:IsShown() or TradeFrame:IsShown()) then
		satchelsReceived = satchelsReceived + 1;
		tableAdd("satchels", satchelsReceived);
		textTable.bagCounter.textFrame:SetText(satchelsReceived);
	elseif event == "LFG_UPDATE_RANDOM_INFO" and running and not inLFGQueue and not inLFRQueue and instanceScan and groupScan then
		-- Tank Scanner
		if scanForTank then
			if satchelFinder("tank", 1046) then
				satchelFound = true;
				textTable.tankScanningText.textFrame:SetText(classScan[3]);
				textTable.tankScanningText.textFrame:SetTextColor(unpack(greenColor));
				textTable.tankdg1.textFrame:SetText(heroicVar[1]);
				if raidWarnNotify then
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[1], ChatTypeInfo["RAID_WARNING"])
				end
				if not MainFrame:IsShown() then
					MainFrame:Show();
				end
			else
				textTable.tankdg1.textFrame:SetText(scanVar[2]);
				textTable.tankScanningText.textFrame:SetText(classScan[2]);
				textTable.tankScanningText.textFrame:SetTextColor(unpack(yellowColor));
			end
		end
		-- Healer Scanner
		if scanForHeal then
			if satchelFinder("heal", 1046) then
				satchelFound = true;
				textTable.healScanningText.textFrame:SetText(classScan[3]);
				textTable.healScanningText.textFrame:SetTextColor(unpack(greenColor));
				textTable.healdg1.textFrame:SetText(heroicVar[1]);
				if raidWarnNotify then
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[2], ChatTypeInfo["RAID_WARNING"])
				end
				if not MainFrame:IsShown() then
					MainFrame:Show();
				end
			else
				textTable.healdg1.textFrame:SetText(scanVar[2]);
				textTable.healScanningText.textFrame:SetText(classScan[2]);
				textTable.healScanningText.textFrame:SetTextColor(unpack(yellowColor));
			end
		end
		-- Dps Scanner
		if scanForDps then
			if satchelFinder("dps", 1046) then
				satchelFound = true;
				textTable.dpsScanningText.textFrame:SetText(classScan[3]);
				textTable.dpsScanningText.textFrame:SetTextColor(unpack(greenColor));
				textTable.dpsdg1.textFrame:SetText(heroicVar[1]);
				if raidWarnNotify then
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[3], ChatTypeInfo["RAID_WARNING"])
				end
				if not MainFrame:IsShown() then
					MainFrame:Show();
				end
			else
				textTable.dpsdg1.textFrame:SetText(scanVar[2]);
				textTable.dpsScanningText.textFrame:SetText(classScan[2]);
				textTable.dpsScanningText.textFrame:SetTextColor(unpack(yellowColor));
			end
		end
		if scanForDps or scanForTank or scanForHeal then
			if not satchelFinder("tank", 1046) and not satchelFinder("heal", 1046) and not satchelFinder("dps", 1046) then
				satchelFound = false;
			end
		end
	end
end

function SatchelScanner_OnLoad(self)
	printm("Satchel Scanner v" .. addonVersion .. " Loaded!");
	printm("->> Type /ss3 for commands!");
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("LFG_UPDATE_RANDOM_INFO");
	self:RegisterEvent("CHAT_MSG_LOOT");
	drawFrames();
	drawText();
	SLASH_SATCHELSCANNER1, SLASH_SATCHELSCANNER2 = "/satchelscan", "/ss3"
	SlashCmdList.SATCHELSCANNER = function(msg)
		if msg == "toggle" then
			if MainFrame:IsShown() then
				MainFrame:Hide();
				showUI = false;
			else
				MainFrame:Show();
				showUI = true;
			end
			datacall("update");
		elseif msg == "reset" then
			satchelsReceived = SatchelScannerDB["satchels"];
			datacall("reset");
		elseif msg == "reset-counter" then
			satchelsReceived = 0;
			datacall("update");
		elseif msg == "config" then
			InterfaceOptionsFrame_OpenToCategory(SatchelScanner.childpanel);
		else
			printm("====== Satchel Scanner ======");
			printm("->> Type '/ss3 toggle' to show/hide the frame");
			printm("->> Type '/ss3 reset' to reset the addon");
			printm("->> Type '/ss3 reset-counter' to reset the bag counter");
			printm("->> Type '/ss3 config' to configure the addon");
		end
		msg = ""
	end
end

function SatchelScanner_OnUpdate(self, elapsed)
	if running and instanceScan and groupScan and not inLFGQueue and not inLFRQueue then
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
		while (self.TimeSinceLastUpdate > UpdateInterval) do
			RequestLFDPlayerLockInfo();
			if satchelFound and playSound and running then
				PlaySoundFile("Sound\\interface\\RaidWarning.ogg", "Master")
				FlashClientIcon()
			end
			self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - UpdateInterval;
		end
	end
end


